import java.util.*;

//
//
// ElectionMonitorThread
//
//
class ElectionMonitorThread extends InternalThread
{
	/**
		The constructor of the election monitor thread
	*/
	public ElectionMonitorThread (Processor processor)
	{
		super (processor);
	}

	/**
		The program executed on this thread
	*/
	public void main ()
	{
		while (true)
		{
			InternalMessage msg = receive ();
			if (msg == null)
				continue;

			if (msg.outerMessage instanceof ReadyMsg)
			{
				ReadyMsg ready = (ReadyMsg)msg.outerMessage;
				if (processor.Group.equals (ready.group) && processor.State == Processor.REORGANIZATION)
				{
					processor.State = Processor.NORMAL;
					send (msg.channel, new ReadyAnswer (true, ready.group));
				}
				else
					send (msg.channel, new ReadyAnswer (false, ready.group));
				continue;
			}

			if (msg.outerMessage instanceof AreYouCoordMsg)
			{
				AreYouCoordMsg ayc = (AreYouCoordMsg)msg.outerMessage;
				if (processor.State == Processor.NORMAL && processor.Coordinator == processor.index)
				{
					send (msg.channel, new AreYouCoordAnswer (true));
				}
				else
					send (msg.channel, new AreYouCoordAnswer (false));
				continue;
			}

			if (msg.outerMessage instanceof AreYouThereMsg)
			{
				AreYouThereMsg ayt = (AreYouThereMsg)msg.outerMessage;
				if (processor.Group.equals (ayt.group) &&
					processor.Coordinator == processor.index &&
					processor.Up.get (msg.channel))
				{
					send (msg.channel, new AreYouThereAnswer (true));
				}
				else
					send (msg.channel, new AreYouThereAnswer (false));
				continue;
			}

			if (msg.outerMessage instanceof AcceptMsg)
			{
				AcceptMsg accept = (AcceptMsg)msg.outerMessage;
				if (processor.State == processor.ELECTION &&
					processor.Coordinator == processor.index &&
					processor.Group.equals (accept.group))
				{
					processor.Up.set (msg.channel);
					send (msg.channel, new AcceptAnswer (true));
				}
				else
					send (msg.channel, new AcceptAnswer (false));
				continue;
			}
		}
	}
}

